/* Arcer.js : 円を描画し移動処理をするクラス*/

class Arcer{
	// コンストラクタ
	constructor(){
		this.x = Math.floor(Math.random() * SCREEN_WIDTH);		// x座標
		this.y = Math.floor(Math.random() * SCREEN_HEIGHT);		// y座標
		this.r = Math.floor(Math.random() * 50) + 1;				// 半径
		this.vx = Math.floor(Math.random() * 3) + 1;				// x方向のスピード
		this.vy = Math.floor(Math.random() * 3) + 1;				// y方向のスピード
	}
	// 描画メソッド
	draw(){
		g.beginPath();
		g.arc(this.x, this.y, this.r, 0, Math.PI*2, false);
		g.stroke();
	}
	// 移動メソッド
	move(){
		this.x += this.vx;
		this.y += this.vy;
		// はね返る
		if(this.x < 0 + this.r){
			this.x = 0 + this.r;
			this.vx = -this.vx;
		}
		else if(this.x > SCREEN_WIDTH - this.r){
			this.x = SCREEN_WIDTH - this.r;
			this.vx = -this.vx;
		}
		if(this.y < 0 + this.r){
			this.y = 0 + this.r;
			this.vy = -this.vy;
		}
		else if(this.y > SCREEN_HEIGHT - this.r){
			this.y = SCREEN_WIDTH - this.r;
			this.vy = -this.vy;
		}
	}
	// 更新処理
	update(){
		this.move();
		this.draw();
	}
}
