/* Rect.js : 円を描画し移動処理をするクラス*/

class Rect{
	// コンストラクタ
	constructor(){
		this.x = Math.floor(Math.random() * SCREEN_WIDTH);		// x座標
		this.y = Math.floor(Math.random() * SCREEN_HEIGHT);		// y座標
		this.width = Math.floor(Math.random() * 50) + 1;				// 幅
		this.height = Math.floor(Math.random() * 50) + 1;				// 高さ 
		this.vx = Math.floor(Math.random() * 10);
		this.vy = Math.floor(Math.random() * 10);
	}
	// 描画メソッド
	draw(){
		g.fillStyle = "green";
		g.fillRect(this.x, this.y, this.width, this.height);
	}
	// 移動メソッド
	move(){
		this.x += this.vx;
		this.y += this.vy;
		// はね返る
		if(this.x < 0 + this.width){
			this.x = 0 + this.width;
			this.vx = -this.vx;
		}
		else if(this.x > SCREEN_WIDTH - this.width){
			this.x = SCREEN_WIDTH - this.width;
			this.vx = -this.vx;
		}
		if(this.y < 0 + this.height){
			this.y = 0 + this.height;
			this.vy = -this.vy;
		}
		else if(this.y > SCREEN_HEIGHT - this.height){
			this.y = SCREEN_WIDTH - this.height;
			this.vy = -this.vy;
		}
	}
	// 更新処理
	update(){
		this.move();
		this.draw();
	}
}
